## How to contribute to DSendcomm

This project is public and does invite public feedback and contributions.

It consists of work done by designers, developers, testers, and producers at Europalab Devices in Munich.

## Submitting improvements and corrections

Please send a [GitLab Pull Request](https://git.europalab.com/cust/proj/pull/new/master/) with a clear list of what you've done (read more about [pull requests](https://docs.gitlab.com/ee/gitlab-basics/add-merge-request.html). Please follow coding conventions (below) and ensure all commits are atomic (one feature per commit.)

Always write a clear log message for your commits. One line messages are fine for small changes, but bigger changes should look like this:

    $ git commit -m 'A brief summary of the commit
    >
    > A paragraph describing what changed and its impact.'

#### **Did you remember to properly sanitise contents?**

Files generated by scientific and electronic design automation software often stores paths, usernames, passwords, and secrets in hard to see locations. Open all files submitted in a text editor and search for things that don't belong.

#### **Do you intend to add a new feature or change an existing one?**

* Suggest your change to the [Europalab Devices release engineer](mailto:engineering@europalab.com) and start editing.
* Don't report a bug (for tracking the feature) until you have collected positive feedback about the change.

## Coding conventions

Start reading our code and you'll get the hang of it. Please optimize for readability.

  * Avoid tab characters
  * Indent using four spaces
  * Put spaces after list items and method parameters (`[1, 2, 3]`, not `[1,2,3]`)
  * Put spaces around operators (`x += 1`, not `x+=1`), and around hash arrows
  * This is open source hardware. Consider the people who will review your design code, and make it look nice for them. It's like driving a car: You like doing donuts when alone, but with passengers make the ride as smooth as possible.

Europalab Devices welcomes contributions from all parties involved. Thanks for helping to develop and improve this project.

Europalab Devices Team
